/*=============================================================================
libxlg
filters/base.c - Basic image operations
  Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003 - 2004
  -- License restrictions apply (Dual FAL/LGPL2)
  -- For details see doc/FAL.txt and doc/LGPL2.txt.
  $Id: base_op.c,v 1.7 2004/04/15 12:34:55 root Exp $
=============================================================================*/
#include <errno.h>
#include <stdio.h>
#include "xlg.h"
#include "filters/strap.h"

//-----------------------------------------------------------------------------
int xlg_flt_copy(XLG_pic *ip, XLG_pic **opp, int argc, char **argv) {
    XLG_pic *c = xlg_pic_dup(ip);
    if(c == NULL) { return -errno; }
    *opp = c;
    return 1;
}

int xlg_flt_flip(XLG_pic *ip, XLG_pic **opp, int argc, char **argv) {
    XLG_pic *op;
    int x, y;

    if((op = *opp = xlg_pic_new(ip->sx, ip->sy)) == NULL) {
        return -errno;
    }

    for(x = 0; x < ip->sx; ++x) {
        for(y = 0; y < ip->sy; ++y) {
            xlg_pic_setpxp(op, x, ip->sy - y - 1, xlg_pic_getpxn(ip, x, y));
        }
    }
    return 1;
}

int xlg_flt_mirror(XLG_pic *ip, XLG_pic **opp, int argc, char **argv) {
    XLG_pic *op;
    int x, y;

    if((op = *opp = xlg_pic_new(ip->sx, ip->sy)) == NULL) {
        return -errno;
    }

    for(x = 0; x < ip->sx; ++x) {
        for(y = 0; y < ip->sy; ++y) {
            xlg_pic_setpxp(op, ip->sx - x - 1, y, xlg_pic_getpxn(ip, x, y));
        }
    }

    return 1;
}

//==[ End of file ]============================================================
