/*=============================================================================
libxlg
filters/laplace.c
  Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2003 - 2004
  -- License restrictions apply (Dual FAL/LGPL2)
  -- For details see doc/FAL.txt and doc/LGPL2.txt.
  $Id: laplace.c,v 1.5 2004/04/05 19:50:14 hirogen2 Exp $
=============================================================================*/
#include <errno.h>
#include <stdio.h>
#include "xlg.h"
#include "filters/strap.h"

//-----------------------------------------------------------------------------
int xlg_flt_laplace(XLG_pic *ip, XLG_pic **opp, int argc, char **argv) {
    XLG_pic *op;
    int x, y;

    if((op = *opp = xlg_pic_new(ip->sx, ip->sy)) == NULL) {
        return -errno;
    }

    for(y = 0; y < ip->sy; ++y) {
        for(x = 0; x < ip->sx; ++x) {
          xlg_pic_setpx_sw(op, x, y,
              (4 * xlg_pic_getpx_sw(ip, x, y) -
                  xlg_pic_getpx_sw(ip, x,y+1) -
                  xlg_pic_getpx_sw(ip, x,y-1) -
                  xlg_pic_getpx_sw(ip, x+1,y) -
                  xlg_pic_getpx_sw(ip, x-1,y)
              ) / 2
              +128
          );
        }
    }
    return 1;
}

//==[ End of file ]============================================================
