#!/bin/rpmbuild -bb
#==============================================================================
# libxlg
# libxlg.spec - RPM specfile
#   Copyright (C) Jan Engelhardt <jengelh [at] linux01 gwdg de>, 2004
#   -- License restrictions apply (Dual FAL/LGPL2)
#   -- For details see doc/FAL.txt and doc/LGPL2.txt.
#   $Id: libxlg.spec,v 1.2 2004/06/07 19:54:45 hirogen2 Exp $
#==============================================================================
Name: libxlg
Version: 20040607
Release: 1
Group: System/Libraries
Packager: Jan Engelhardt <jengelh [at] linux01 gwdg de>
URL: http://linux01.org:2222/prog-libxlg.php
Summary: Private library

Vendor: Jan Engelhardt <jengelh [at] linux01 gwdg de>
Source: http://linux01.org:2222/f/%name-%version.tbz2
%define source http://linux01.org:2222/f/%name-%version.tbz2
License: FAL/LGPL2

BuildRoot: %_tmppath/%name-%version-build
Prefix: /usr/local
AutoReqProv: no
Provides: libxlg.so.0.0

%description
While I took a computer course in image manipulation algorithms in
Java in August 2003 at the XLAB Gttingen, I left a codebase back
implementing these algorithms. These have now been tidied up and put
into a library. This is nothing sensationary, just basic algorithms
to experiment with.

The worst thing that could happen in this course was that it was
designed to use Java as programming language. Really none of the
participants knew Java, only C-style basics (which helped a lot!), it
was just a matter of implementing the algorithms in Java. A "picture"
class was already programmed in the past, however since Java was too
much for me, I just reinvented that wheel in C, and made it a
command-line tool to read and write PPM files, which could then be
displayed using xv.

Since others will probably also take part in this course some day,
and I am pretty sure they do not know all of Java either, I provide
the established codebase, especially the picture handling, which cost
me about 2 hours of the 3 days, as an aid.

This established code base, now known as libxlg currently has three
parts: the picture handling XLG_pic, general filter handling
XLG_filter and matrix storage XLG_matrix.

Authors:
--------
    Jan Engelhardt <jengelh [at] linux01 gwdg de>

#------------------------------------------------------------------------------
%prep
cd "$RPM_SOURCE_DIR"/;
copy_from_local=0;
if [ ! -e %name-%version.tbz2 ]; then
    if [ -d /home/hirogen2/f/%name ]; then
        copy_from_local=1;
    else
        wget -c %source;
    fi;
fi;

cd "$RPM_BUILD_DIR"/;
rm -Rf %name %name-%version;
if [ "$copy_from_local" == "1" ]; then
    cp -Rav /home/hirogen2/f/%name ./;
    mv %name %name-%version;
    make -C %name-%version cleanx;
else
    tar -jvxf %name-%version.tbz2;
fi;

find %name-%version -type d -name CVS -print0 | xargs -0 rm -Rfv;

#------------------------------------------------------------------------------
%build
cd "$RPM_BUILD_DIR"/%name-%version/;
numcpu=$[`grep ^processor /proc/cpuinfo | wc -l`+1];

%ifarch i686
./Makefile.RUN -j$numcpu MARCH=i686 MCPU=i686 DEBUG=0;
%else
%ifarch i586
./Makefile.RUN -j$numcpu MARCH=i586 MCPU=i586 DEBUG=0;
%else
./Makefile.RUN -j$numcpu DEBUG=0;
%endif
%endif

#------------------------------------------------------------------------------
%install
prefix="$RPM_BUILD_ROOT";
[ "$prefix" != "/" -a -d "$prefix" ] && rm -Rfv "$prefix";
cd "$RPM_BUILD_DIR"/%name-%version/;

usrlib="$prefix/usr/lib";
usrinc="$prefix/usr/include";

install -d "$usrlib";
install -d "$usrinc";
install -m0755 libxlg.so.0.0 "$usrlib"/;
ln -fs libxlg.so.0.0 "$usrlib"/libxlg.so;
install -m0644 xlg.h "$usrinc"/;

install -d "$prefix""%_defaultdocdir";
cp -av doc "$prefix""%_defaultdocdir"/%name;

#------------------------------------------------------------------------------
%clean
prefix="$RPM_BUILD_ROOT";
[ "$prefix" != "/" -a -d "$prefix" ] && rm -Rfv "$prefix";

#------------------------------------------------------------------------------
%files
/usr/include/xlg.h
/usr/lib/libxlg.so.0.0
%docdir %_defaultdocdir/%name
%_defaultdocdir/%name

#------------------------------------------------------------------------------
%post
ln -fs libxlg.so.0.0 %prefix/lib/libxlg.so.0;
ln -fs libxlg.so.0 %prefix/lib/libxlg.so;

#==[ End of file ]=============================================================
